]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
Make the Xonotic maps no longer exempt of the sRGB requirement, now that all fulfill...
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index 2810ff8f3834bbc7728fa074d02fd7f927ebaea9..bbcedec0ddbc6a2db0fb9056a28b3a75d488ce6f 100755 (executable)
@@ -7,8 +7,8 @@ url_http=http://beta.xonotic.org/autobuild-bsp/
 url_ssh=xonotic-beta:autobuild-bsp/
 build_cachedir="$HOME/xonotic-map-compiler.cache/"
 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
-build_override="-bsp_timeout 1800 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
-screenshot_override="9 600 +g_ctf 1"
+build_override="-bsp_timeout 3600 -vis_timeout 10800 -light_timeout 18000 -minimap_timeout 900 -scale_timeout 900 -timeout_stealing 0.8"
+screenshot_override="9 900 5 +g_ctf 1"
 
 getthemap_fail=false
 
@@ -163,7 +163,7 @@ buildthemap()
        M=$3
        blobhash=$4
        commithash=$5
-       if HEAD "$url$M-$blobhash.pk3"; then
+       if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
                continue
        fi
 
@@ -172,22 +172,43 @@ buildthemap()
        git checkout -f "$commithash"
 
        if [ -n "$IRCSPAM" ]; then
-               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM || true
        fi
+
        t0=`date +%s`
-       (
-               cd maps
-               sz=`grep '^size ' "$M.mapinfo" 2>/dev/null || true`
-               if [ -n "$sz" ]; then
-                       minimap_override="-minimap + -minmax ${sz#size }"
-               else
-                       minimap_override=
-               fi
-               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $minimap_override $build_override > "$M.log" 2>&1
+
+       # It's sad that we must enforce this rule by code.
+       if grep -- '-nosRGB' "maps/$M.map.options" >/dev/null; then
+               is_nosrgb=true
+       else
+               is_nosrgb=false
+       fi
+       allow_build=true
+       if $is_nosrgb; then
+               case "$REFNAME" in
+                       master|refs/heads/master|origin/master|refs/remotes/origin/master)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34ERROR: map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               allow_build=false
+                               ;;
+                       *)
+                               if [ -n "$IRCSPAM" ]; then
+                                       echo "\ 34WARNING:\ f map $M uses -nosRGB. This is not acceptable in master. Please fix." | $IRCSPAM || true
+                               fi
+                               ;;
+               esac
+       fi
+
+       set +e
+       $allow_build && (
+               cd ../..
+               misc/tools/xonotic-map-compiler-optionsfile "data/xonotic-maps.pk3dir/maps/$M" $build_override > "data/xonotic-maps.pk3dir/maps/$M.log" 2>&1
        )
        status=$?
+       set -e
        if ! [ -f "maps/$M.bsp" ]; then
-               echo >>"$M.log" "ERROR: No BSP file"
+               echo >>"maps/$M.log" "ERROR: No BSP file"
        fi
        t1=`date +%s`
        dt=$(($t1 - $t0))
@@ -202,7 +223,10 @@ buildthemap()
        rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
        rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
-               $IRCSPAM < "maps/$M.irc"
+               $IRCSPAM < "maps/$M.irc" || true
+       fi
+       if [ -n "$BUILD_ONE" ]; then
+               exit
        fi
 }
 
@@ -213,7 +237,7 @@ screenshotthemap()
        M=$3
        blobhash=$4
        commithash=$5
-       if HEAD "$url$M-$blobhash/"; then
+       if lwp-request -m HEAD "$url$M-$blobhash/$M-000000.jpg"; then
                continue
        fi
 
@@ -222,34 +246,44 @@ screenshotthemap()
                continue
        fi
 
-       rm -rf ~/.xonotic
+       rm -rf ~/.xonotic/data
+       mkdir -p ~/.xonotic/data
        (
                cd ../..
                if [ -n "$DISPLAY" ]; then
-                       misc/tools/xonotic-map-screenshot "$M" $screenshot_override +"scr_screenshot_name \"$M-\""
+                       misc/tools/xonotic-map-screenshot "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\""
                else
-                       #startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"scr_screenshot_name \"$M-\"" -- :8
-                       #startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"scr_screenshot_name \"$M-\"" -gl_driver /usr/local/lib/gallium3d/libGL.so -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
-                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
+                       case "$DRIVER" in
+                               gl)
+                                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- :8
+                                       ;;
+                               soft|*)
+                                       startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"vid_soft 1" $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
+                                       ;;
+                       esac
                fi
-       )
-       if ! mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
-               if [ -n "$IRCSPAM" ]; then
-                       #ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 1 > "maps/$M.ircss"
-                       ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > "maps/$M.ircss"
-               fi
-               return 1
-       fi
-       if [ -n "$IRCSPAM" ]; then
-               #ss2spam "$M" "$url$M-$blobhash/" "$REFNAME" "$commithash" 0 > "maps/$M.ircss"
-               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > "maps/$M.ircss"
+       ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
+       good=false
+       if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
+               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
+       else
+               mkdir "$M-$blobhash"
+               ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
        fi
+       mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
+       mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
        chmod 1777 "$M-$blobhash"
        ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
        rsync -vaSHP "$M-$blobhash" "$url_ssh"
        rsync -vaSHP "$M" "$url_ssh""latest/"
        if [ -n "$IRCSPAM" ]; then
-               $IRCSPAM < "maps/$M.ircss"
+               # It takes about 5 minutes for the server to update.
+               sleep 360  # Cut it one more minute of slack.
+
+               $IRCSPAM < "$M-$blobhash/$M.ircss" || true
+       fi
+       if [ -n "$BUILD_ONE" ]; then
+               exit
        fi
 }
 
@@ -357,7 +391,14 @@ case "$1" in
                runmakeindex
                ;;
        download)
-               cd data/xonotic-maps.pk3dir
+               if ! which unzip >/dev/null 2>&1; then
+                       echo "Cannot find unzip, bailing out"
+                       exit 1
+               fi
+               if ! cd data/xonotic-maps.pk3dir >/dev/null 2>&1; then
+                       echo "data/xonotic-maps.pk3dir does not exist, not downloading"
+                       exit 0
+               fi
                rundownload
                cd ../..
                echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"